//---------------- common page functions ---------------------
// toggle value  from 0 to 1 && from 1 to 0 && send WRIN to ACL
function chToggleVal(chan, val, tag)
{
	var msg = {id:"NEST"};
	msg[txtChn[chan]] = {id:"WRIN"};
	msg[txtChn[chan]][tag] = (val ? 0 : 1);
	host.sendCmsg(msg);
}
function toggleVal(tag1, tag2, val)
{
	var msg = {id:"NEST"};
	msg[tag1] = {id:"WRIN"};
	msg[tag1][tag2] = (val ? 0 : 1);
	host.sendCmsg(msg);
}
function setListActive(list, id)
{
	var txt="";

	id=toUnsignedDword(id);	// all ID's are dwords in C code
	if(!list.goFirst(list)) return "";
	do
	{
		if(list.id==id)
		{
			list.flags|=1;
			list.icon=1;
			txt=list.text;
		}
		else
		{
			if(list.flags&2)
				list.flags=2;
			else
				list.flags=0;
			list.icon=0;
		}
	} while(list.goNext());
	return txt;
}
function getListActiveTxt(list)
{
	if(!list.goFirst(list)) return "";
	do
	{
		if(list.flags&1) return list.text;
	} while(list.goNext());
	return "";
}
function setListSelection(list, id)
{
	var pos=0;
	id=toUnsignedDword(id);	// all ID's are dwords in C code
	if(!list.goFirst(list)) return;
	do
	{
		if(list.id==id)
		{
			list.select(pos);
			return;
		}
		pos++;
	} while(list.goNext());
	list.select(0);
}
function inLimit(numb, min, max)
{
	return (numb < min ? min : (numb > max ? max : numb));
}

// -------- monitor stuff -------------
// making volume table
// dB values from -851 to 0
//	pos values from 0 to 1000
const mon_vol_table = [
	[-851, 0],
	[-700, 50],
	[-300, 377],
	[-200, 531],
	[0, 1000]
];
// will be precalculated from table above on boot
var mon_vol_idx_to_db = [];
var mon_vol_db_to_idx = [];
function monDbToIdx(db){
	if (db < mon_const.gain_min)
		return 0;
	if (db > mon_const.gain_max)
		return 1000;
	var l = mon_vol_table.length;
	for (var i=0; i<l; i++){
		var val = mon_vol_table[i];
		if (db == val[0])
			return val[1];
		else if (db < val[0]){
			var val2 = mon_vol_table[i-1];
			return Math.round(val[1] + (val2[1] - val[1]) *((db - val[0])/(val2[0] - val[0])));
		}
	}
	return 1000; // should never happen
}
function monIdxToDb(idx){
	if (idx < 0)
		return mon_const.gain_min;
	if (idx > 1000)
		return mon_const.gain_max;
	var l = mon_vol_table.length;
	for (var i=0; i<l; i++){
		var val = mon_vol_table[i];
		if (idx == val[1])
			return val[0];
		else if (idx < val[1]){
			var val2 = mon_vol_table[i-1];
			return Math.round(val[0] + (val2[0] - val[0]) *((idx - val[1])/(val2[1] - val[1])));
		}
	}
	return mon_const.gain_max; // should never happen
}
function adjustMonGain(tag, mon_ind, delta, sensit)
{
	if(mon_mute[mon_ind]) return; // if monitor is muted

	var mon = pages.main[mon_ind];
	var prev = mon.vol_val;
	var newval = prev + (sensit * delta)

	mon.vol_val=clamp(newval, 0, 1000);
	mon.update();

	var msg = {id:"WRNI"};
	msg[tag] = mon_vol_idx_to_db[mon.vol_val];
	host.sendCmsg(msg);

	mon.atag = tag;
	mon.ackTimeout = host.resetTimeout(mon.ackTimeout, 500, ackVolume, mon);

// pops up mon palette if timer controls are visible
	pages.main.popMonCtr();
}
function indiMonGain(gain, mon_ind)
{
	var mon = pages.main[mon_ind];
	var db = clamp(gain, mon_const.gain_min, mon_const.gain_max);

	mon.vol_val = mon_vol_db_to_idx[db];
	monSetKnobAngle(mon);
}
function monSetKnobAngle(mon)
{
	// full turn 280 degrees
	var angle = Math.floor((mon.vol_val / 1000) * 280);
	mon.vol_knob.setAngle(angle);
}
function monSetMute(mon, mute)
{
	if (mute == 0){	//mute ON
		mon.met.hide();
		mon.vol_knob.hide();
		mon.mute_icon.show();
		mon.vol_visible = 2;	//2 indicates mute icon is on
	}else{
		mon.mute_icon.hide();
		mon.vol_knob.hide();
		mon.met.show();
		mon.vol_visible = 0;
	}
}

function ackVolume()
{
	var msg = {id:"WRIN"};
	msg[this.atag] = mon_vol_idx_to_db[this.vol_val];
	host.sendCmsg(msg);
	this.ackTimeout = null;
}

// --------------------------
function panGetIdx(val_l, val_r)
{
	var ret = pan_const.val_table_center;
	var tab = pan_const.val_table;
	for(var ind in tab)
	{
		if (tab[ind][0] == val_l && tab[ind][1] == val_r)
		{
			ret = parseInt(ind);
			break;
		}
	}
	return ret;
}
function srcIsStereo(src_type)
{
	return (src_type==srct.line || src_type==srct.computer || src_type==srct.codec);
}

// ------------------------- * number functions * -------------------------

function clamp(val, min, max) {return val<min?min:(val>max?max:val);}

function knobCreate(fr, x, y, w, label)
{
	var knob=
	{
		val:  gui.newLabel(fr, x         , y   ,  w, 14, '', prop_value),
		knob: gui.newKnob (fr, x+(w-22)/2, y+15, 22, 22, "img/knob_22px.png"),
		lbl:  gui.newLabel(fr, x         , y+38,  w, 14, '', prop_value)
	};
	knob.lbl.setText(label);
	knob.focus=function(on)
	{
		var prop=on?propAct:propOff;

		this.val.setProps(prop);
		this.lbl.setProps(prop);
		this.knob.setIndex(on?2:0);
	};
	return knob;
}

/*
** knobSetGain
**
** knob : object including: {knob: <knob>, val: <label>}
** value: new value
** limit: object including: {gain_min, gain_max}
*/
function knobSetGain(knob, value, limit, units)
{
	var angleNrm;

	value=clamp(value, limit.gain_min, limit.gain_max);
	if(limit.gain_min<0 && limit.gain_max>0)
	{
		if(value<0)
			angleNrm=0.5-(value/limit.gain_min)/2;
		else
			angleNrm=0.5+(value/limit.gain_max)/2;
	}
	else
		angleNrm=(value-limit.gain_min)/(limit.gain_max-limit.gain_min);

	knob.knob.setAngleNrm(angleNrm);
	knob.val.setText(host.sprintf("%.1f %s", value/10, units));
	return angleNrm;
}

/*
** knobSetValue
**
** knob : object including: {knob: <knob>, val: <label>}
** value: new value
** limit: object including: {min, max, mid, units}
*/
function knobSetValue(knob, value, limit)
{
	var angleNrm;

	value=clamp(value, limit.min, limit.max);
	if('mid' in limit)
	{
		if(value<limit.mid)
			angleNrm=((value-limit.min)/(limit.mid-limit.min))/2;
		else
			angleNrm=0.5+((value-limit.mid)/(limit.max-limit.mid))/2;
	}
	else
		angleNrm=(value-limit.min)/(limit.max-limit.min);

	knob.knob.setAngleNrm(angleNrm);
	knob.val.setText(host.sprintf("%.1f %s", value/10, limit.units));
	return angleNrm;
}

/*
** knobSetFreq
**
** knob : object including: {knob: <knob>, val: <label>}
** value: new value
** limit: object including: {min, max}
*/
function knobSetFreq(knob, value, limit)
{
	var angleNrm, text;

	value=clamp(value, limit.min, limit.max);

	angleNrm=(value-limit.min)/(limit.max-limit.min);
	knob.knob.setAngleNrm(angleNrm);

	if(value<1000)
		text=host.sprintf("%d Hz", value);
	else
		text=host.sprintf("%.2f kHz", value/1000);
	knob.val.setText(text);
	return angleNrm;
}

function valAdjust(value, delta, limit)
{
	var step;

	step=('step' in limit)?limit.step:1;
	if('fn' in limit)
		value=limit.fn(value, delta*step);
	else if(step>0 && delta!=0)
	{
		if(step>1 && (value%step))
		{
		// adjust value
			if(delta>0)
				value=Math.floor(((value<0)?(value-(step-1)):value)/step)*step;
			else
				value=Math.floor(((value<0)?value:(value+(step-1)))/step)*step;
		}
		value+=step*delta;
	}
	return clamp(value, limit.min, limit.max);
}

// ------------------------- * message helper functions * -------------------------

function getSourceList(channel, onlyActive)
{
// special override switch to show all sources (usefull when there is no advertisment)
	if(onlyActive && host.cfgGetString('scr.showAllSrcs', 'no')=='yes')
		onlyActive=false;
	return host.sendCmsgRq({id:"READ", bSRLE:0, bCHNR:channel, bSTAT:(onlyActive?1:0)});
}

host.sendNestCmsg=function(tag, nest_msg)
{
	var msg={id:'NEST'};

	msg[tag]=nest_msg;
	return host.sendCmsg(msg);
}

host.sendNestCmsgRq=function(tag, nest_msg)
{
	var msg={id:'NEST'}, rmsg;

	msg[tag]=nest_msg;
	rmsg=host.sendCmsgRq(msg);
// retrun nested response message
	return (rmsg && (tag in rmsg))?rmsg[tag]:null;
}

host.sendChnCmsg=function(chn, chn_msg)
{
	var msg={id:'NEST'};

	msg[txtChn[chn]]=chn_msg;
	return host.sendCmsg(msg);
}

host.sendChnCmsgRq=function(chn, chn_msg)
{
	var msg={id:'NEST'}, tag, rmsg;

	if(!(chn in txtChn)) return null;
	tag=txtChn[chn];

	msg[tag]=chn_msg;
	rmsg=host.sendCmsgRq(msg);
// retrun channel response message
	return (rmsg && (tag in rmsg))?rmsg[tag]:null;
}

function chnRequestMeter(chn, type, mtr_id, on)
{
	var meter=(chn-1)*4+type;

// request meters from Engine
	host.requestMeter(meter, on);
// link visual control to meter id
	gui.linkMeter(mtr_id, on?meter:0);
}

// calculate eq frequencies for log scale
function eqSetLogFreq(graph, x0, x1, x100, xStep)
{
	var eqfreq=[];
	var n, x, f;

// x goes through entire x scale
	for(n=0, x=x0; x<=x1; x++, n+=2)
	{
	// here we calculate freq in Hz at given x point
	// x100 is the point at which f == 100Hz
	// xStep is the period: distance between 100Hz and 1kHz and 10kHz
		f=Math.pow(10, 2+((x-x100)/xStep));
		eqfreq[n+0]=f;
		eqfreq[n+1]=x;
	}
	graph.setFreq(eqfreq);
}

// ------- utility functions that probably will have to go to C -----------
function toUnsignedDword(num)
{
	return num<0?4294967296+num:num;
}
function strToArr(str)
{
	var l = str.length;
	var a = [];
	for (var i=0; i<l; i++)
		a[i] = str.charCodeAt(i);
	return a;
}
function $(src)
{
	var i, s, v;

	switch(typeof(src))
	{
	case 'string': return '"'+src+'"';
	case 'number': return src+'';
	case 'boolean': return src?'true':'false';
	case 'function': return 'function';
	case 'undefined': return 'undefined';
	case 'object':
		if(src==null) return 'null';
		if(gui.isWnd(src)) return 'window';
		s="{\n";
		for(i in src)
		{
			v=$(src[i]);
			s+="  "+i+": "+v.replace(new RegExp("\n", "g"), "\n  ")+"\n";
		}
		s+="}";
		return s;
	}
	return 'unknown';
}
