// ------------------------ common GUI functions ------------------------
const color_labelON =gui.rgb(129,169,191);
const color_labelOFF=gui.rgb(200,200,200);

/*
** GUI_createSmallMeter
**
** Creates small unlinked confidence meter,
** those meters are usually found on source selection screens
*/
function GUI_createSmallMeter(frame, x, y, id)
{
	var ml, mr;

	ml=gui.newMeter(frame, x+0, y, 8, 24, "img/mtr_source.png");
	mr=gui.newMeter(frame, x+9, y, 8, 24, "img/mtr_source.png");
	ml.setBars(8); ml.setPoints([-500, 0, 0, 8]);
	mr.setBars(8); mr.setPoints([-500, 0, 0, 8]);
	gui.createMeter(id, 4, null, [ml, mr]);
}

/*
** GUI_createMediumMeter
**
** Creates medium sized linked meter,
** those meters are usually found on custom external meter screen
*/
function GUI_createMediumMeter(frm, x, y, id, engId)
{
	var mf, ml, mr, p;

	mf=gui.newFrame(frm, x,  y, 70, 196, "img/meter_mtrx.png");
	ml=gui.newMeter(mf,  5, 11, 14, 184, "img/mbar_ext.png"); ml.setBars(46); ml.setPoints([-500, 0, 0, 46]);
	mr=gui.newMeter(mf, 51, 11, 14, 184, "img/mbar_ext.png"); mr.setBars(46); mr.setPoints([-500, 0, 0, 46]);
	p=gui.newPicture(mf,  5, 0, 60, 8, "img/meter_ovr.png");
	gui.createMeter(id, 4, p, [ml, mr]);
	gui.linkMeter(id, engId);
}

function GUI_createMeterLabel(frm, x, y, label)
{
	var l={};

	l.bg =gui.newPicture(frm,  x, y, 62, 17, "img/mtr_lbl.png");
	l.lbl=gui.newLabel  (l.bg, 3, 2, 55, 13, '', {font:"myriad-roman-10", color:color_labelOFF, align:align.alignCenter});
	l.lbl.setText(label);
	l.label=label;
	l.active=false;
	l.custom=false;
	l.update=function()
	{
		if(l.custom || l.active)
		{
			this.bg.setIndex(1);
			this.lbl.setProps({color:color_labelON});
		}
		else
		{
			this.bg.setIndex(0);
			this.lbl.setProps({color:color_labelOFF});
		}
	};
	l.activate=function(on)
	{
		if(this.active==on) return;

		this.active=on;
		this.update();
	};
	l.setText=function(t)
	{
		if(t==null)
		{
			this.lbl.setText(this.label);
			if(this.custom)
			{
				this.custom=false;
				this.update();
			}
		}
		else
		{
			this.lbl.setText(t);
			if(!this.custom)
			{
				this.custom=true;
				this.update();
			}
		}
	};

	return l;
}
